minor improvements
[distro-setup] / switch-mail-host
1 #!/bin/bash
2 set -x
3 set -eE -o pipefail
4 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
5
6 usage() {
7 cat <<EOF
8 Usage: ${0##*/} OLD_HOST NEW_HOST
9
10 Adjust home network dns so NEW_HOST resolves locally if it is on the
11 local network. Turn off mail receiving on OLD_HOST, run btrbk to move
12 mail to NEW_HOST, turn on mail receiving on NEW_HOST.
13
14 -w Don't try to ssh to wrt. Should only be used in unusual network situation.
15 -h|--help Print help and exit.
16
17 Note: Uses GNU getopt options parsing style
18 EOF
19 exit $1
20 }
21
22 ##### begin command line parsing ########
23
24 update_wrt=true # default
25 temp=$(getopt -l help wh "$@") || usage 1
26 eval set -- "$temp"
27 while true; do
28 case $1 in
29 -w) update_wrt=false; shift ;;
30 -h|--help) usage ;;
31 --) shift; break ;;
32 *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
33 esac
34 done
35
36
37 (( $# == 2 )) || usage 1
38
39 old_host=$1
40 new_host=$2
41 source /a/bin/bash_unpublished/source-semi-priv
42
43 if [[ $old_host != $MAIL_HOST ]]; then
44 read -p "warning: \$old_host != \$MAIL_HOST: $old_host != $MAIL_HOST, proceed? y/N "
45 if [[ $REPLY != [yY] ]]; then
46 exit 1
47 fi
48 fi
49
50 if [[ $new_host == "$HOSTNAME" ]]; then
51 localhost_new=true
52 new_shell=
53 else
54 localhost_new=false
55 new_shell="ssh $new_host"
56 fi
57
58 old_shell="ssh $old_host"
59 if [[ $old_host == "$HOSTNAME" ]]; then
60 old_shell=
61 fi
62
63 if [[ ! $new_host || ! $old_host ]]; then
64 echo "$0: bad args. see script"
65 exit 1
66 fi
67
68 at_home=false
69 if [[ $HOSTNAME == tp ]] || [[ $HOSTNAME == frodo ]] || timeout -s 9 5 ssh wrt.b8.nz :; then
70 at_home=true
71 fi
72 echo "$0: at_home = $at_home"
73
74 source /a/bin/bash_unpublished/source-semi-priv
75 #### begin convert private hostnames to public hostnames ####
76 #if ! $at_home; then
77 # for var in old_host new_host; do
78 # case ${!var} in
79 # tp)
80 # eval $var=$HOME_DOMAIN
81 # ;;
82 # esac
83 # done
84 #fi
85 #### end convert private hostnames to public hostnames ####
86
87
88 # because our port forward is not robust enough, we can't use proxy command,
89 # todo: setup vpn so this is all taken care of.
90 if ! $update_wrt; then
91 wrt_shell=:
92 else
93 wrt_shell="ssh wrt.b8.nz"
94 fi
95
96 btrbk_test="systemctl is-active btrbk.service"
97 while $new_shell $btrbk_test || $old_shell $btrbk_test; do
98 echo "$0: btrbk is running on new or old host. sleeping for 8 seconds"
99 sleep 6
100 echo "$0: testing for btrbk activity in 2 seconds"
101 sleep 2
102 done
103
104 new_hostname=$($new_shell hostname)
105
106 ########### end initial processing, begin actually modifying things ##########
107
108 restore_new_btrbk=false
109 if $new_shell systemctl is-active btrbk.timer; then
110 $new_shell sudo systemctl stop btrbk.timer
111 restore_new_btrbk=true
112 fi
113 restore_old_btrbk=false
114 if $old_shell systemctl is-active btrbk.timer; then
115 $old_shell sudo systemctl stop btrbk.timer
116 restore_old_btrbk=true
117 fi
118
119
120 $new_shell bash -xs <<'EOF'
121 set -eE
122 if mountpoint -q /m; then sudo umount /m; fi
123 if mountpoint -q /o; then sudo umount /o; fi
124 EOF
125
126 # if new_host is not on home network, make mail.iankelling.org not resolve
127 # on the home network.
128 if [[ $new_host == $HOSTNAME ]] && ! $at_home; then
129 echo | $wrt_shell cedit mail_host /etc/hosts || [[ $? == 1 ]] # 1 means file changed.
130 else
131 $wrt_shell bash -xs $new_host <<'EOFOUTER'
132 new_host=$1
133 cedit mail_host /etc/hosts <<EOF || /etc/init.d/dnsmasq restart
134 $(grep "\b$new_hostname\b" /etc/hosts | awk '{print $1}') mail.iankelling.org
135 EOF
136 EOFOUTER
137 fi
138
139 $old_shell primary-setup $new_hostname
140
141 /a/bin/distro-setup/install-my-scripts
142
143 if $localhost_new; then
144 btrbk-run -s $old_host -m /o
145 else
146 btrbk-run -t $new_host -m /o
147 fi
148
149 $new_shell primary-setup $new_hostname
150
151 if $restore_new_btrbk; then
152 $new_shell sudo systemctl start btrbk.timer
153 fi
154 if $restore_old_btrbk; then
155 $old_shell sudo systemctl start btrbk.timer
156 fi